<?php
/**
 * @package		
 * @copyright		Copyright (C) 2012 CNPINTEGRATIONS.COM. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * See COPYRIGHT.php for copyright notices and details.
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgSystemRememberBackendMe extends JPlugin
{

	function plgSystemRememberBackendMe(& $subject, $config) {
		parent::__construct($subject, $config);
	}

	function onAfterInitialise()
	{
		//$app = &JFactory::getApplication();
		$app = JFactory::getApplication();

		// No remember me for admin
		if (!$app->isAdmin()) {
			return;
		}

		$user = JFactory::getUser();
		if (!$user->get('gid'))
		{
			jimport('joomla.utilities.utility');
			$hash = JApplication::getHash('JLOGIN_REMEMBER_BACKEND');

			if ($str = JRequest::getString($hash, '', 'cookie', JREQUEST_ALLOWRAW | JREQUEST_NOTRIM))
			{
				jimport('joomla.utilities.simplecrypt');

				//Create the encryption key, apply extra hardening using the user agent string
				$key = JUtility::getHash(@$_SERVER['HTTP_USER_AGENT']);

				$crypt	= new JSimpleCrypt($key);
				$str	= $crypt->decrypt($str);

				$options = array();
				$options['silent'] = true;
				if (!$app->login(@unserialize($str), $options)) {
					// Clear the remember me cookie
					setcookie( JUtility::getHash('JLOGIN_REMEMBER_BACKEND'), false, time() - 86400, '/' );
				}
			}
		}
	}
}