<?php
/**
 * @package		
 * @copyright		Copyright (C) 2012 CNPINTEGRATIONS.COM. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * See COPYRIGHT.php for copyright notices and details.
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.plugin.plugin');

/**
 * Remember untill browser close Plugin
 *SessionExtender
 */
class plgUserSessionExtender extends JPlugin {

	function plgUserSessionExtender(& $subject, $config)
	{
		parent::__construct($subject, $config);
	}

	function onUserLogin($user, $options)
	{
		// Initialize variables
		$success = true;
		$mode = $this->params->get('staymode',1);
		$app = JFactory::getApplication();
		$isAdmin = $app->isAdmin();
		if ($mode == 1 && $isAdmin)
			return $success;
		if ($mode == 2 && !$isAdmin)
			return $success;
		
		// Set the credentials
		$credentials = Array('username'=>$user['username'], 'password'=>$user['password']);
		
		// Set the remember me cookie if remember me is not enabled
		if ( (!(isset($options['remember']))) || (!($options['remember']))  )
		{
			jimport('joomla.utilities.simplecrypt');
			jimport('joomla.utilities.utility');

			//Create the encryption key, apply extra hardening using the user agent string
			$key = JApplication::getHash(@$_SERVER['HTTP_USER_AGENT']);

			$crypt = new JSimpleCrypt($key);
			$rcookie = $crypt->encrypt(serialize($credentials));
			// set lifetime to 0, or when browser closes
			$lifetime = 0;
			$config = JFactory::getConfig();
			$cookie_domain = $config->get('cookie_domain', '');
			$cookie_path = $config->get('cookie_path', '/');
			if (!$isAdmin)
				setcookie(JApplication::getHash('JLOGIN_REMEMBER'), $rcookie,  $lifetime, $cookie_path, $cookie_domain);
			else
				setcookie(JApplication::getHash('JLOGIN_REMEMBER_BACKEND'), $rcookie,  $lifetime, $cookie_path, $cookie_domain);
		}
		
		return $success;
	}

}
